#!/usr/bin/perl
#
# Statistics for itraxp.trf (itraxp traffic-file)
#   by Dmitry Pankov (2:5022/81)
#
# Based on:
#   statlog.pl for FTrack by Sergey Venediktov (2:5030/1346)
#
# Usage:
#   Set $inlog to your node address. 
#   Add to your tracking script following code, which should be executed 
#   afrer routing mails and before moving to outbound:
#   === Cut===
#   sub logmails {
#     @header = ("-------------------- Packed on %localtime% %localdate% --------------------",
#               "From : %FromName%, %From%",
#               "To   : %ToName%, %To%",
#               "Subj : %Subject% ",
#               "Date : %Time% ",
#               "Size : %MsgLength%",
#               "Via  : %RouteTo%",
#               "-----------------------------------------------------------------------");
#     WriteString('@ /var/log/fido/itraxp.trf', 'header.');
#   }
#   === Cut===
#   Then call script:
#   st_itraxp.pl /path/to/your/fraffic/log >/where/to/put/result
#
# Examples:
#   st_itraxp.pl /var/log/fido/itraxp.trf >/var/spool/fido/itraxp.out
#   st_itraxp.pl c:\fido\logs\itraxp.trf >c:\fido\stat\itraxp.out
#
#   Thats all. Enjoy! :-)

if (!-f $ARGV[0]) {die "You must specify log-file!"};
$inlog = $ARGV[0];
open LOG_FILE, $inlog or die 'Cannot open file: '.$inlog;

$node='2:5022/81';

$size=0;
$msgcount=0;

while(<LOG_FILE>)
{
    chomp;
    s/\r$//;
    if (/Packed\s+on\s+(\d+:\d+:\d+\s+\d+\/\d+\/\d+)\s+/i)
    {
        if ($stdata ne '') {$enddata=$1;}
        else {$stdata=$1;}
        $msgcount++;
        $lastfaddr='';
        $lasttoaddr='';
    }

    if (/\AFrom\s+:\s+.*\s+($node\.\d+)\Z/i || /\AFrom\s+:\s+.*\s+($node)\Z/i)
    {
        $from{$1}++;
        $lastfaddr=$1;
    }
    if (/\ATo\s+:\s+.*\s+($node\.\d+)\Z/i)
    {
        $to{$1}++;
        $lasttoaddr=$1;
    }

    if (/\ASize\s+:\s+(\d+)\Z/i)
    {
        $size += $1;
        if ($lasttoaddr ne '') { $tosize{$lasttoaddr} += $1; };
        if ($lastfaddr ne '') { $fromsize{$lastfaddr} += $1; };
    }
}
close LOG_FILE;

printf "\n\n> Netmail traffic from %s to %s\n\n", $stdata, $enddata;

print "  Outbound calculate:\n";
print "ͻ\n";
print " Address            Mails   Bytes  \n";
print "͹\n";

     foreach (sort {
     my $aa = $a;
     my $bb = $b;
         $aa =~ s/^.*\.//g;
         $bb =~ s/^.*\.//g;
         $aa <=> $bb;
     } keys %from)
{
    printf (" %-17s %6d %8d \n", $_,$from{$_},$fromsize{$_});
}
print "ͼ\n\n";

print "  Inbound calculate:\n";
print "ͻ\n";
print " Address            Mails   Bytes  \n";
print "͹\n";
     foreach (sort {
     my $aa = $a;
     my $bb = $b;
         $aa =~ s/^.*\.//g;
         $bb =~ s/^.*\.//g;
         $aa <=> $bb;
     } keys %to)
{
    printf (" %-17s %6d %8d \n", $_,$to{$_},$tosize{$_});
}
print "ͼ\n";

printf "  Total routed:      %6d  %8d\n\n", $msgcount, $size;
