sub managers;     # check mail for AreaFix and AllFix
sub Bad_Dest;     # check destination System from nodelist
sub Bad_Orig;     # check origin System from nodelist
sub CheckFileAtt; # check fileattach attr mail
sub echomail;     # routed echomail
sub loopmsgs;
sub orphanmsgs;
sub mailpack;
sub logmails;

sub procmain {

    Scan(NetMail);

    while (ReadMsg()) {
	managers();
	tracking();
	echomail();
	loopmsgs();
	orphanmsgs();
	AddIntl();
	mailpack();
    }
}

sub managers {

    my($echoflag, $fileflag);
    $echoflag = ">/var/spool/fido/flags/areafix.itx";
    $fileflag = ">/var/spool/fido/flags/allfix.itx";
    
    if (SelectTo(EchoArea_Mgr)) {
	if (Select('@attribute !RECEIVED')) {
	    ChangeMail('-t @ Areafix');
	    open(FLAG, $echoflag);
	    close(FLAG);
	} else {
	    Move(RobotMail);
	}
    } elsif (SelectTo(FileArea_Mgr)) {
	if (Select('@attribute !RECEIVED')) {
	    ChangeMail('-t @ Allfix');
	    open(FLAG, $fileflag);
	    close(FLAG);
	} else {
	    Move(RobotMail);
	}
    }
}


sub tracking {

    CheckFileAtt();
    if (SelectTo('~System')) {
	if (SelectTo('System')) {
	    if (SelectTo('@Attribute NULL')) {
		Kill();
	    }
	} else {
	    # Mails to my points
	    # Bounce non existant Points
	    if (SelectTo('!My_Points') && SelectTo('!My_Point_BBS')) {
		if (SelectTo(My_Own)) {
		    @hdr = (" ", "*** Mail to %OldTo% (unknown) copy to %System% ***", " ");
		    ChangeMail('-t System', '-l @ hdr.');
		} else {
		    @hdr = (" ", "   *** Point %TO%, %TONAME% is not found on %SYSTEM% ***", " ");
	    	    CopyArea(BadMail, '-l @ hdr.');
	    	    Bounce('-h wronpoint', '-s @ Bounced by %%PROGRAM%% on %%System%% (Unknown Point)');
		}
	    }
	}
    } else {
	# bounce bad destination ( except the nodes in SKIP see DATA.CFG )
        Bad_Dest;
    }
    
    if (SelectFrom('~System')) {
    } else {
	# forward bad origin  ( except the nodes in SKIP see DATA.CFG )
	Bad_Orig;
    }

    if (Select('@attribute AUDIT')) {
	$from = GetFrom();
	CreateMail(netmail, "@ $from", '-h arqsend', '-a StripFlags', '-f @ 2:5020/9999 %PROGRAM%');
    }

    if (SelectTo(My_Address) && SelectTo('My_Own') && SelectTo('@Attribute RRQ')) {
	SetAttribute('@Attribute !RRQ');
	$from = GetFrom();
	CreateMail(netmail, "@ $from", '-h rrqsend', '-a StripFlags', '-f @ 2:5020/9999 %PROGRAM%');
	AddHeader(rrqhead);
    }
    
    if (SelectTo('My_Own') && SelectTo('System')) {
	@addline = (" ", "*** Mail to %System% copy to 2:5020/9999.1 ***", " ");
	ChangeMail('-t @ 2:5020/9999.1', '-l @ addline.');
    }

}


sub CheckFileAtt {
    if (Select('@Attribute FILE')) {
	CheckPath (InPath);
	SetAttribute('@ATTRIBUTE KFS');
	if (SelectTo('!Skip') && SelectTo('!~MyLink')) {
	    if (SelectFrom('!My_Address') && SelectFrom('!My_Own')) {
		@hdr = (" ", "*** Warning! Bad File Attach. ***", " ");
		Move(BadMail, '-l @ hdr.');
	    }
	}
    }
}

sub Bad_Dest {
    if (SelectTo('!Skip') && SelectTo('!Nodelist')) {
	@hdr = (" ", "   *** Address To - %To% not found in my nodelist ***", " ");
	CopyArea (Badmail, '-l @ hdr.');
	if (SelectFrom('!Skip') && SelectFrom('!Nodelist')) {
	    Kill
	} else {
	    Bounce ('-h bad_dest', '-a @ clear PRIVATE');
	}
    }
}

sub Bad_Orig {
    if (SelectFrom('!Skip') && SelectFrom('!Nodelist')) {
	@hdr = (" ", "   *** Address From - %From% not found in my nodelist ***", " ");
	CopyArea(Badmail, '-l @ hdr.');
	$to = GetTo();
	InvalideTearOrig();
#	SubstText("~ * Origin:", " + Origin:");
#	SubstText("~ ---", "-+-");
	ChangeMail('-h bad_orig', "-t @ $to", '-f @ 2:5020/9999 %PROGRAM%', '-a @ clear PRIVATE');
    }
}

sub echomail {
    @hdr = (" ", "   *** This messages is not Netmail, it is echomail. ***", " ");
    if (Select('EchoAttribute')) {
	Move('BadMail', '-l @ hdr.');
    }
    
    @kludge = GetKludges();
    
    foreach (@kludge) {
	if (substr($_, 0, 8) eq "SEEN-BY:" || substr($_, 0, 5) eq "PATH:") {
	    Move('BadMail', '-l @ hdr.');
	    last;
	}
    }
    
}

sub loopmsgs {
    if (Select('@Attribute Loop2')) {
        CopyArea(LoopMail);
        @hdr = GetHdr();
        $hdr[2] = $hdr[0];
        $hdr[3] = $hdr[1];
        $hdr[0] = ExpandMacro('PROGRAM');
        $hdr[1] = '2:5020/960';
        Bounce("-t @ $hdr[3] $hdr[2]", "-f @ $hdr[1] $hdr[0]", '-a @ clear', '-h looping');
    }
}

sub orphanmsgs {
    if (SelectTo('!SKIP') && SelectTo('@Attribute ORPHAN')) {
	@hdr = (" ", "   *** Orpgan attribute is found in this mail ***",  " ");
	CopyArea(Badmail, '-l @ hdr.');
	Bounce(orphan, '-a @ clear PRIVATE');
    }
}


sub mailpack {

    if (SelectTo('@Attribute IMM')) {
	# On some binkley systems IMM is not possible
	SetAttribute('@ATTRIBUTE !IMM CRASH');
    }
    if (SelectFrom('My_Address') && SelectFrom('My_Own') && SelectFrom('@Attribute DIR')) {
    } else {
	SetAttribute('@Attribute !Dir !Crash !IMM');
    }
    # Directrouting ?
    if (SelectTo(DirectFlags)) {
	# Direct-Hold Routing ?
	if (SelectTo('@Attribute Hold')) {
	    SetRouting(DirectHoldRouting);
	    SetFlavor('HOLD');
	}
	# Maybe you have a filerouting
	if (SelectTo('@Attribute FILE')) {
	    SetRouting(FileRouting);
	}
    } else {
        SetRouting(NetRouting);
    }
    if (SelectTo('!SYSTEM') && SelectTo('!NOOUTFLAGS')) {
	if (SelectTo(SKIP) || SelectTo(Nodelist)) {
	    SetAttribute(NOPKTFLAGS);
	    CopyArea(TransMail, '-a @ SENT');
	    logmails();
#	    RecodeOut();
	    Move(Binkout);
	}
    }
}




sub logmails {
    if (SelectFrom('!Filearea_Mgr') && SelectFrom('!Echoarea_Mgr') &&
					    SelectFrom('!Me_Robot')) {
	
	if (SelectTo('!Filearea_Mgr') && SelectTo('!Echoarea_Mgr') &&
						SelectTo('!Me_Robot')) {
	
	    @header = ("----------------%localtime% %localdate%----------------",
		       "Date  : %Time% "
,
		       "From  : %From% (%FromName%)"
,
		       "To    : %To% (%ToName%)"
,
		       "Subj  : %Subject% "
,
		       "MsgId : %msgidfrom%",
		       "Route : %routeto%", " ");
		       
	    WriteString('@ /var/spool/fido/logs/netmail.log', 'header.');
	}
    }
}

